from .pipe import DEFAULT_PERMISSIONS
from .pipe_reader_server import PipeReaderServer
from .pipe_writer_server import PipeWriterServer


class PipeIOServer(PipeReaderServer, PipeWriterServer):
    # pylint: disable=abstract-method
    def __init__(self, in_pipe, out_pipe, permissions=DEFAULT_PERMISSIONS):
        super().__init__(
            in_pipe=in_pipe,
            out_pipe=out_pipe,
            permissions=permissions
        )

    def _init_io_thread(self):
        PipeReaderServer._init_io_thread(self)
        PipeWriterServer._init_io_thread(self)
